package dev.micle.totemofreviving.item.charge;

import dev.micle.totemofreviving.TotemOfReviving;
import dev.micle.totemofreviving.config.Config;
import dev.micle.totemofreviving.item.totem.NetheriteTotemItem;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Rarity;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.StringTextComponent;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.world.World;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import java.util.List;

public class ChargeItem extends Item {
	public ChargeItem() {
		super(new Item.Properties().tab(TotemOfReviving.ITEM_GROUP).stacksTo(64).rarity(Rarity.COMMON));
	}
	
	@Override
	@OnlyIn(Dist.CLIENT)
	@ParametersAreNonnullByDefault
	public void appendHoverText(ItemStack stack, @Nullable World world, List<ITextComponent> tooltip, ITooltipFlag tooltipFlag) {
		if (isEnabled(stack)) {
			tooltip.add(new StringTextComponent(TextFormatting.WHITE + "Used for charging its corresponding totem."));
		} else {
			tooltip.add(new StringTextComponent(TextFormatting.RED + "Totem is disabled!"));
		}
		super.appendHoverText(stack, world, tooltip, tooltipFlag);
	}
	
	public static boolean isEnabled(ItemStack stack) {
		Item item = stack.getItem();
		if (item instanceof StrawChargeItem) { return Config.Server.getStrawTotemConfig().getIsEnabled(); }
		if (item instanceof IronChargeItem) { return Config.Server.getIronTotemConfig().getIsEnabled(); }
		if (item instanceof DiamondChargeItem) { return Config.Server.getDiamondTotemConfig().getIsEnabled(); }
		if (item instanceof NetheriteTotemItem) { return Config.Server.getNetheriteTotemConfig().getIsEnabled(); }
		return false;
	}
}
