package dev.micle.totemofreviving.item.crafting;

import dev.micle.totemofreviving.item.charge.ChargeItem;
import dev.micle.totemofreviving.setup.ModRecipes;
import net.minecraft.inventory.CraftingInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipeSerializer;
import net.minecraft.item.crafting.ShapedRecipe;
import net.minecraft.world.World;

public class ChargeRecipe extends ExtendedShapedRecipe {
	public ChargeRecipe(ShapedRecipe recipe) {
		super(recipe);
	}
	
	@Override
	public IRecipeSerializer<?> getSerializer() {
		return ModRecipes.CHARGE_RECIPE.get();
	}
	
	@Override
	public boolean matches(CraftingInventory inventory, World world) {
		if (!ChargeItem.isEnabled(getResultItem())) {
			return false;
		}
		return getBaseRecipe().matches(inventory, world);
	}
	
	@Override
	public ItemStack assemble(CraftingInventory inventory) {
		return getBaseRecipe().getResultItem();
	}
}
